<?php
require_once 'paykeeper.class.php';
/**
 * Шаблон платежа через систему PayKeeper
 * 
 * @package    PayKeeper
 * @author     paykeeper.ru
 * @version    1.1
 */
if (!defined('DIAFAN')) {
    include dirname(dirname(dirname(dirname(dirname(__FILE__))))) . '/includes/404.php';
}
$pay = DB::query_fetch_array("SELECT * FROM {payment_history} WHERE element_id=%d LIMIT 1",$result["orderid"]);
//$pay["payment"] = DB::query_fetch_array("SELECT * FROM {payment} WHERE id=%d AND payment='%s' LIMIT 1", $pay["payment_id"], 'paykeeper');
$paykeeper_url = $result["url"] ;
$secret_seed = $result['paykeeper_secret'];
$tax = $result['paykeeper_tax'];

$payment_parameters = http_build_query(array(
    "clientid" => $result["clientid"],
    "orderid" => $result["orderid"],
    "sum" => $result["sum"],
    "phone" => $result["phone"],
));
$cart = $this->diafan->_order->get($result["orderid"]);

$pk_obj = new PaykeeperPayment();
$pk_obj->setOrderParams(
    $result["sum"],
    $result["clientid"]??'anonymous',
    $result["orderid"],
    $result['client_email']??'',
    $result['phone']??'',
    '',
    $result['url'],
    $secret_seed
);

if($tax!='none')$pk_obj->setUseTaxes();
$item_index = 0;
$tax_amount = 0;
foreach ($result['cart'] as $item)
{
    $name = $item["name"];
    $price = $item["price"];
    $quantity = $item["count"];
    if ($quantity == 1 && $pk_obj->single_item_index < 0)
        $pk_obj->single_item_index = $item_index;
    if ($quantity > 1 && $pk_obj->more_then_one_item_index < 0)
        $pk_obj->more_then_one_item_index = $item_index;
    $sum = $item["summ"];
    $pk_obj->updateFiscalCart($pk_obj->getPaymentFormType(),
        $name, $price, $quantity, $sum, $tax);
    $item_index++;
}

$summ = (float)$result['delivery']['summ']??0;
if (isset($result['delivery']['summ']) && $summ > 0)
{
    $shipping_taxes = array("tax" => "none", "tax_sum" => 0);
    $pk_obj->setShippingPrice(floatval($result['delivery']['summ']));
    $shipping_name = $result['delivery']['name'];
    if (!$pk_obj->checkDeliveryIncluded($pk_obj->getShippingPrice(), $shipping_name)
        && $pk_obj->getShippingPrice() > 0) {
        $pk_obj->setUseDelivery(); //for precision correct check
        $pk_obj->updateFiscalCart($pk_obj->getPaymentFormType(), $shipping_name,
            $pk_obj->getShippingPrice(), 1, $pk_obj->getShippingPrice(), $shipping_taxes["tax"]);
        $pk_obj->delivery_index = count($pk_obj->getFiscalCart())-1;
    }
}
if ($result['additional'])
{
    foreach ($result['additional'] as $item)
    {
        $pk_obj->updateFiscalCart($pk_obj->getPaymentFormType(),
            $item['name'], $item['summ'], 1, $item['summ'], $tax);
    }
}
$pk_obj->correctPrecision();
$fiscal_cart_encoded = json_encode($pk_obj->getFiscalCart());
if ($pk_obj->getPaymentFormType() == "create") { //create form
    $to_hash = number_format($pk_obj->getOrderTotal(), 2, ".", "") .
        $pk_obj->getOrderParams("clientid")     .
        $pk_obj->getOrderParams("orderid")      .
        $pk_obj->getOrderParams("service_name") .
        $pk_obj->getOrderParams("client_email") .
        $pk_obj->getOrderParams("client_phone") .
        $pk_obj->getOrderParams("secret_key");
    $sign = hash ('sha256' , $to_hash);
    $form = '
                <h3>Сейчас Вы будете перенаправлены на страницу банка.</h3> 
                <form name="payment" id="pay_form" action="'.$pk_obj->getOrderParams("form_url").'" accept-charset="utf-8" method="post">
                <input type="hidden" name="sum" value = "'.$pk_obj->getOrderTotal().'"/>
                <input type="hidden" name="orderid" value = "'.$pk_obj->getOrderParams("orderid").'"/>
                <input type="hidden" name="clientid" value = "'.$pk_obj->getOrderParams("clientid").'"/>
                <input type="hidden" name="client_email" value = "'.$pk_obj->getOrderParams("client_email").'"/>
                <input type="hidden" name="client_phone" value = "'.$pk_obj->getOrderParams("client_phone").'"/>
                <input type="hidden" name="service_name" value = "'.$pk_obj->getOrderParams("service_name").'"/>
                <input type="hidden" name="cart" value = \''.htmlentities($fiscal_cart_encoded,ENT_QUOTES).'\' />
                <input type="hidden" name="sign" value = "'.$sign.'"/>
                <input type="submit" id="button-confirm" value="Оплатить"/>
                </form>
               <script text="javascript">
               document.addEventListener("DOMContentLoaded", document.querySelector("#pay_form").submit());
                 </script>';
}
else
{
    $payment_parameters = array(
        "clientid"=>$pk_obj->getOrderParams("clientid"),
        "orderid"=>$pk_obj->getOrderParams('orderid'),
        "sum"=>$pk_obj->getOrderTotal(),
        "phone"=>$pk_obj->getOrderParams("phone"),
        "client_email"=>$pk_obj->getOrderParams("client_email"),
        "cart"=>$fiscal_cart_encoded);
    $query = http_build_query($payment_parameters);
    $query_options = array("http"=>array(
        "method"=>"POST",
        "header"=>"Content-type: application/x-www-form-urlencoded",
        "content"=>$query
    ));
    $context = stream_context_create($query_options);

    $err_num = $err_text = NULL;
    if( function_exists( "curl_init" )) { //using curl
        $CR = curl_init();
        curl_setopt($CR, CURLOPT_URL, $pk_obj->getOrderParams("form_url"));
        curl_setopt($CR, CURLOPT_POST, 1);
        curl_setopt($CR, CURLOPT_FAILONERROR, true);
        curl_setopt($CR, CURLOPT_POSTFIELDS, $query);
        curl_setopt($CR, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($CR, CURLOPT_SSL_VERIFYPEER, 0);
        $result = curl_exec( $CR );
        $error = curl_error( $CR );
        if( !empty( $error )) {
            $form = "<br/><span class=message>"."INTERNAL ERROR:".$error."</span>";
            return false;
        }
        else {
            $form = $result;
        }
        curl_close($CR);
    }
    else { //using file_get_contents
        if (!ini_get('allow_url_fopen')) {
            $form_html = "<br/><span class=message>"."INTERNAL ERROR: Option allow_url_fopen is not set in php.ini"."</span>";
        }
        else {
            $form = file_get_contents($paykeeper_url, false, $context);
        }
    }
}
if ($form  == "") {
    $form = '<h3>Произошла ошибка при инциализации платежа</h3><p>$err_num: '.htmlspecialchars($err_text).'</p>';
}
echo $form;



